<template>
  <div>
    <b-dropdown id="dropdown-save" right :text="$t('Save')" variant="primary">
      <b-dropdown-item-button @click="downloadRDF(currentDefinition)">{{
        $t("Download")
      }}</b-dropdown-item-button>
      <b-dropdown-item-button
        v-if="Object.keys(completeApplicationProfile.inheritedParts).length > 0"
        @click="downloadRDF(completeApplicationProfile.definition)"
        >{{ $t("DownloadComplete") }}</b-dropdown-item-button
      >
      <b-dropdown-item-button :disabled="readonly" @click="openStoreModal">{{
        $t("Submit")
      }}</b-dropdown-item-button>
      <b-dropdown-item-button
        v-if="curation_process"
        :disabled="!applicationProfile || applicationProfile.state !== 1"
        @click="openReviewModal"
        >{{ $t("SendToReview") }}</b-dropdown-item-button
      >
    </b-dropdown>
    <EditModal
      :application-profile="applicationProfile"
      :definition="definition"
      label-prefix="store"
      ok-label-key="Submit"
      :open="storeModalOpen"
      @close="closeStoreModal"
      @save="saveAP"
      @stateChange="stateChange"
    />
    <template v-if="afterStoreExists">
      <AfterStoreModal
        :last-access-token-url="lastAccessTokenUrl"
        :open="afterStoreModalOpen"
        @close="closeAfterStoreModal"
        @save="closeAfterStoreModal"
      />
    </template>
    <template v-if="reviewModalExists">
      <ReviewModal
        :application-profile="applicationProfile"
        :open="reviewModalOpen"
        @close="closeReviewModal"
        @save="closeReviewModal"
      />
    </template>
    <template v-if="storeToastExists">
      <StoreToast v-model:visible="storeToastVisible" />
    </template>
    <template v-else>
      <DefaultStoreToast v-model:visible="storeToastVisible" />
    </template>
    <Teleport to="body">
      <div class="bottom-0 end-0 toast-container position-fixed">
        <b-toast
          id="storingToast"
          v-model="storingToastVisible"
          :title="$t('defaultStoringToastTitle')"
          :auto-hide="false"
        >
          <b-spinner small label="Storing"></b-spinner>
          {{ $t("defaultStoringToastDescription") }}
        </b-toast>
        <b-toast
          id="storeFailedToast"
          v-model="storeFailedToastVisible"
          :title="$t('defaultStoreFailedToastTitle')"
          auto-hide-delay="5000"
          variant="danger"
          body-class="text-bg-light"
        >
          {{ $t("defaultStoreFailedToastDescription") }}
        </b-toast>
      </div>
    </Teleport>
  </div>
</template>

<script lang="ts">
import type { ApplicationProfile } from "@/types/application-profile";
import { serializeRDFDefinition } from "@/util/linkedData";
import type { Dataset } from "@rdfjs/types";

import { saveAs } from "file-saver";

import serviceProvider from "@/util/service-providers/service-provider";

import { defineComponent, type PropType } from "vue";
import State from "@/types/state";

import { useMainStore } from "@/store";

import EmptyComponent from "@/components/Layout/EmptyComponent.vue";
const afterStoreExists = serviceProvider.uiElements.AfterStoreModal
  ? true
  : false;
const AfterStoreModal =
  serviceProvider.uiElements.AfterStoreModal ?? EmptyComponent;
const reviewModalExists = serviceProvider.uiElements.ReviewModal ? true : false;
const ReviewModal = serviceProvider.uiElements.ReviewModal ?? EmptyComponent;
const storeToastExists = serviceProvider.uiElements.StoreToast ? true : false;
const StoreToast = serviceProvider.uiElements.StoreToast ?? EmptyComponent;

export default defineComponent({
  name: "SubmissionActions",
  components: {
    AfterStoreModal,
    ReviewModal,
    StoreToast,
  },
  props: {
    applicationProfile: {
      required: true,
      type: Object as PropType<ApplicationProfile>,
    },
    completeApplicationProfile: {
      required: true,
      type: Object as PropType<{
        definition: Dataset;
        inheritedParts: Record<
          string,
          {
            applicationProfile: ApplicationProfile;
            definition: Dataset;
          }
        >;
      }>,
    },
    currentDefinition: {
      required: true,
      type: Object as PropType<Dataset>,
    },
    definition: {
      required: true,
      type: Object as PropType<Dataset>,
    },
    readonly: {
      default: false,
      type: Boolean,
    },
  },
  setup() {
    const mainStore = useMainStore();

    return { mainStore };
  },
  data() {
    return {
      afterStoreModalOpen: false,
      curation_process: serviceProvider.curation_process,
      lastAccessTokenUrl: "",
      reviewModalOpen: false,
      setState: 0,

      afterStoreExists,
      storeToastExists,
      reviewModalExists,

      storeModalOpen: false,
      storeToastVisible: false,
      storeFailedToastVisible: false,
      storingToastVisible: false,
    };
  },
  methods: {
    closeAfterStoreModal() {
      this.afterStoreModalOpen = false;
      this.lastAccessTokenUrl = "";
    },
    closeReviewModal() {
      this.reviewModalOpen = false;
    },
    closeStoreModal() {
      this.storeModalOpen = false;
    },
    async downloadRDF(dataset: Dataset) {
      const filename = "applicationProfile.ttl";
      const blob = new Blob(
        [await serializeRDFDefinition(dataset, "text/turtle")],
        {
          type: "text/plain;charset=utf-8",
        },
      );
      saveAs(blob, filename);
    },
    openReviewModal() {
      this.reviewModalOpen = true;
    },
    openStoreModal() {
      this.storeModalOpen = true;
    },
    async saveAP() {
      this.storingToastVisible = true;
      this.$emit("updateDefinition");
      try {
        // Think of a different solution
        // eslint-disable-next-line vue/no-mutating-props
        this.applicationProfile.state = this.setState;
        const storedApplicationProfile =
          await serviceProvider.apiConnection.storeApplicationProfile(
            this.applicationProfile,
            this.definition,
          );
        if (
          storedApplicationProfile?.accessToken &&
          storedApplicationProfile.accessToken !== "-1" &&
          storedApplicationProfile.state === State.DRAFT
        ) {
          this.lastAccessTokenUrl = `${window.location.href.replace(
            window.location.hash,
            "",
          )}#/editor?applicationProfile=${
            this.applicationProfile.base_url
          }&accessToken=${storedApplicationProfile.accessToken}`;
          if (AfterStoreModal) {
            this.afterStoreModalOpen = true;
          }
          this.storeToastVisible = true;
        } else {
          this.storeToastVisible = false;
        }
        this.$emit("storedApplicationProfiles", storedApplicationProfile);
      } catch {
        this.storeFailedToastVisible = true;
      }
      // Without the timeout, the storing toast will not disappear
      setTimeout(() => (this.storingToastVisible = false), 1);
      this.storeModalOpen = false;
    },
    stateChange(state: State) {
      this.setState = state;
      this.$emit("stateChange", state);
    },
  },
});
</script>
